package WebFlow.GemCalculator;

import WebFlow.*;
import WebFlow.event.*;
import java.io.*;
import java.util.*;
import java.text.*;

public class GemCalculatorImpl extends BeanContextChildSupport
                implements WebFlow.GemCalculator.GemCalculatorOperations {

 String msg_;
 org.omg.CORBA.Object peer;
 private FileReader fr,fr1;
 private BufferedReader in;

    /* osprey4.npac.syr.edu */

 private String gemDir = "/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/GEM/";
 private String HelpFile=gemDir+"calculator/helpfile.txt";
 private String UsageFile=gemDir+"calculator/usagefile.txt";
 private String resultFile    = gemDir+"calculator/GEMresult.txt";
 private String dislocInput   = gemDir+"calculator/dislocIn.txt";
 private String dislocOutput  = gemDir+"calculator/dislocOut.txt";
 private String simplexInput  = "/tmp/simplex.input";
 private String simplexOutput = gemDir+"calculator/simplex.txt";
 private String DislocSimplex = gemDir+"calculator/compare.txt";
 private String dislocExe = "/npac/home/webflow/gem/bin/disloc";
 private String disloc2simplex = "/npac/home/webflow/gem/bin/dis2sim.pl";
 private String simplexExe = "/npac/home/webflow/gem/bin/simplex";
 private String simplexCmd = simplexExe+" "+simplexInput+" "+simplexOutput;
 private String gpsFile = "/npac/home/haupt/GEM/gps.gd";

    /* main.npac.syr.edu */
		  /*
 private String gemDir = "C:\\Jigsaw\\Jigsaw\\Jigsaw\\WWW\\GEM\\";
 private String HelpFile=gemDir+"calculator\\helpfile.txt";
  private String UsageFile=gemDir+"calculator\\usagefile.txt";
 private String resultFile    = gemDir+"GEMresult.txt";
 private String dislocInput   = gemDir+"dislocIn.txt";
 private String dislocOutput  = gemDir+"disloc.output";
 private String simplexInput  = gemDir+"simplex.input";
 private String simplexOutput = gemDir+"simplex.txt";
 private String DislocSimplex = gemDir+"compare.txt";
 private String dislocExe = "C:\\Disloc\\disloc.exe";
 private String disloc2simplex = "\\npac\\home\\webflow\\gem\\bin\\dis2sim.pl";
 private String simplexExe = "\\npac\\home\\webflow\\gem\\bin\\simplex";
 private String simplexCmd = simplexExe+" "+simplexInput+" "+simplexOutput;
 private String gpsFile = gemDir+"gps.gd";
 */
 private boolean lockH = false; 
 private boolean lockU = false; 
 private String nextLine;
 private boolean simplex=false;
 private double nullValue=-99999.0;

   /* disp variables */
   private  double[] argsV;
   private  String[] params;
  int Ms,point;
  int[] parm;
   double[] vds,vdip,vlen,vss,vstr,vwid,vthr;
   double depth, dip, lat, length, lon, M, mu, slip, strike, ds, ss;
   double threshold, thrust, width, v;
   Vector Ids  = new Vector();
   double[] rr;
   double[] si;
   Hashtable rIdx = new Hashtable();
   Vector vlat = new Vector();   //separate for each scenario
   Vector vlon = new Vector();   //separate for each scenario
   Vector gvlat = new Vector();  //concatenation of vlats
   Vector gvlon = new Vector();  //concatenation of vlons
   double x[];
   double y[];



    public GemCalculatorImpl(org.omg.CORBA.Object peer, String msg)
	throws WebFlow.NullPointerException {
    
        super(peer); 
        this.peer = peer;
        msg_ = msg;
    }

    public void test() {
        System.out.println("GemCalculator is up");
    }

  public boolean isHelp() {
      boolean value = true;
      if(lockH) {
         value=false;
         System.out.println("Help file is locked");
      }
      else {
         try {
         fr = new FileReader(HelpFile);
         in = new BufferedReader(fr);
         }
         catch (Exception e) {
           System.out.println(e);
           value=false;
         }
      }
      return value;
  }     

  public boolean isResult() {
      boolean value = true;

      try {
      fr = new FileReader(resultFile);
      in = new BufferedReader(fr);
      }
      catch (Exception e) {
      System.out.println(e);
      value=false;
      }

      return value;
  }     

  public boolean isCompare() {
      boolean value = true;

      try {
      fr = new FileReader(DislocSimplex);
      in = new BufferedReader(fr);
      }
      catch (Exception e) {
      System.out.println(e);
      value=false;
      }

      return value;
  }     

  public boolean isUsage() {
      boolean value = true;
      if(lockU) {
         value=false;
         System.out.println("Usage file is locked");
      }
      else {
         try {
         fr = new FileReader(HelpFile);
         in = new BufferedReader(fr);
         }
         catch (Exception e) {
           System.out.println(e);
           value=false;
         }
      }
      return value;
  }     

  public String getHelpLine() {
    try { 
      nextLine = in.readLine();
      if(nextLine == null) {
        nextLine="koniec";
        in.close();
        lockH=false;
      }
    }
    catch (IOException e) {
      nextLine="IOEexception in getHelpLine \n"+e.toString();
      //in.close();
      lockH=false;
    }
   return nextLine;
  }

  public String getResultLine() {
    try { 
      nextLine = in.readLine();
      if(nextLine == null) {
        nextLine="koniec";
        in.close();
      }
    }
    catch (IOException e) {
      nextLine="IOEexception in getResultLine \n"+e.toString();
      //in.close();
    }
   return nextLine;
  }
   
  public String getUsageLine() {
    try { 
      nextLine = in.readLine();
      if(nextLine == null) {
        nextLine="koniec";
        in.close();
      }
    }
    catch (IOException e) {
      nextLine="IOEexception in getResultLine \n"+e.toString();
      //in.close();
    }
   return nextLine;
  }
    
  public String getCompareLine() {
    try { 
      nextLine = in.readLine();
      if(nextLine == null) {
        nextLine="koniec";
        in.close();
      }
    }
    catch (IOException e) {
      nextLine="IOEexception in getCompareLine \n"+e.toString();
      // in.close();
    }
   return nextLine;
  }


    public void CompareDS() {
	// compares input of disloc and output of simplex
        // x,y,depth,dip,length,width,strike-slip,dip-slip
      String[] dislocInput = new String[8];  
      String[] simplexResult = new String[8];

      dislocInput[0]= "0"; //x
      dislocInput[1]= "0"; //y
      dislocInput[2]= (new Double(argsV[3])).toString(); //depth
      dislocInput[3]= (new Double(argsV[4])).toString(); //dip
      dislocInput[4]= (new Double(argsV[8])).toString(); //length;
      dislocInput[5]= (new Double(argsV[10])).toString(); //width;
      dislocInput[6]= "1"; //strike-slip;
      dislocInput[7]= "1"; //dip-slip;

      StringTokenizer st;
      try {
         fr1 = new FileReader(simplexOutput);
         in = new BufferedReader(fr1);
         while((nextLine = in.readLine())!=null) {
          st = new StringTokenizer(nextLine);
          int n=st.countTokens();
          if(n==3) {
            String name=st.nextToken();
            String dummy=st.nextToken();
            String value=st.nextToken();
            System.out.println(name+dummy+value);
            if(name.equals("x")) simplexResult[0]=value;
            if(name.equals("y")) simplexResult[1]=value;
            if(name.equals("depth")) simplexResult[2]=value;
            if(name.equals("dip")) simplexResult[3]=value;
            if(name.equals("length")) simplexResult[4]=value;
            if(name.equals("width")) simplexResult[5]=value;
            if(name.equals("strike-slip")) simplexResult[6]=value;
            if(name.equals("dip-slip")) simplexResult[7]=value;
	  } // n==3
	 } //while
         fr1.close();

      FileWriter fw9 = new FileWriter(DislocSimplex);
      fw9.write("\n          compare \n");
      fw9.write("Variable    Disloc.in  Simplex.out \n");
      fw9.write("          x "+dislocInput[0]+" "+simplexResult[0]+"\n");
      fw9.write("          y "+dislocInput[1]+" "+simplexResult[1]+"\n");
      fw9.write("      depth "+dislocInput[2]+" "+simplexResult[2]+"\n");
      fw9.write("        dip "+dislocInput[3]+" "+simplexResult[3]+"\n");
      fw9.write("     length "+dislocInput[4]+" "+simplexResult[4]+"\n");
      fw9.write("      width "+dislocInput[5]+" "+simplexResult[5]+"\n");
      fw9.write("strike-slip "+dislocInput[6]+" "+simplexResult[6]+"\n");
      fw9.write("   dip-slip "+dislocInput[7]+" "+simplexResult[7]+"\n");
      fw9.write("   --------- end ------- ");
      fw9.flush();
      fw9.close();
      }
      catch (Exception e) {
       System.out.println("cannot write compare:"+DislocSimplex);
       System.out.println(e);}
    }  
 
 // ********************************************
 // run the Calculator
 // ********************************************

  public double[] run(int[] parm, double[] argsV, boolean simplex){

    System.out.println("start calculator");
    this.parm = parm;
    this.argsV = argsV; 
    this.simplex = simplex;

     NumberFormat nf=NumberFormat.getInstance();
     nf.setMaximumFractionDigits(2);
     nf.setMinimumFractionDigits(2);    

    System.out.println(parm[0]+" "+parm[1]+" "+parm[2]+" "+parm[3]);

    /*reinitialize arrays*/ 
     
    setDefaultValues(); 
    M = argsV[2];
    threshold = argsV[11];
    if(simplex) threshold=100.0;
    /* set thrust */
    if(argsV[12]<nullValue) {
        if(Math.abs(argsV[4] - 90.0)< 1E-5) argsV[12]=1.0;
        else argsV[12]=0;
    }

    Vector r = new Vector();


    for (int i=0;i<4;i++) {
    if (parm[i]>0) {


      // Set up location of epicenter, number of stations, strike of fault
      String dummy;
      String currentId; 
      StringTokenizer st;
      try {
      FileReader reader = new FileReader(gpsFile);
      BufferedReader in = new BufferedReader(reader);
      vlat.removeAllElements();
      vlon.removeAllElements();
      while((nextLine = in.readLine()) != null) {
         st = new StringTokenizer(nextLine);
         currentId = st.nextToken();
         dummy = st.nextToken();
         if(dummy.equals("LAT")) {
                  dummy=st.nextToken();
                  dummy=st.nextToken();
                  vlat.addElement(dummy);
                  gvlat.addElement(dummy);
                  Ids.addElement(currentId); 
	 }
         if(dummy.equals("LON")) {
                  dummy=st.nextToken();
                  dummy=st.nextToken();
                  vlon.addElement(dummy);
                  gvlon.addElement(dummy);
	 }
      }
      reader.close();
      } catch (Exception e) {System.out.println(e);}
      

System.out.println("now write disp1.txt");

      try {
      FileWriter writer = new FileWriter(gemDir+"disp1.txt");
      writer.write(argsV[1]+" "+argsV[0]+"\n");

      for(int ii=0;ii<vlat.size();ii++) {
         writer.write((String)vlon.elementAt(ii)+" "+(String)vlat.elementAt(ii)+"\n");
	 }
      writer.flush();
      writer.close(); 
      } catch (Exception e) {System.out.println(e);}


    System.out.println("..... disp1.txt written");

      
      // Convert lon/lat to x/y coordinates


      double d2r = Math.acos(-1.0)/180.0;
      double factor = d2r*Math.cos(d2r*argsV[0])*
               (6378.139*(1.0-Math.sin(d2r*argsV[0])*Math.sin(d2r*argsV[0])/298.247));  

      
      x = new double[vlat.size()]; 
      y =new double[vlat.size()];
      String tmpstr;
      double tmpval;
    
      for (int ii=0;ii<vlat.size();ii++) {
          try {
             tmpstr=(String)vlon.elementAt(ii);
             tmpval=(new Double(tmpstr)).doubleValue();
             x[ii]=(tmpval - argsV[1])*factor;           
             tmpstr=(String)vlat.elementAt(ii);
             tmpval=(new Double(tmpstr)).doubleValue();
             y[ii]=(tmpval - argsV[0])*111.32;
	  } catch (Exception e) {System.out.println(e);}
      }

      //      for (int ii=0;ii<10;ii++) {
      //	System.out.println(x[ii]+" "+y[ii]);
      //}           

      //set fault parameters
         argsV[4]=  vdip[i];
         argsV[5] = vstr[i];  
         argsV[6] = vds[i];
         argsV[7] = vss[i];
         argsV[8] = vlen[i];
         argsV[10] = vwid[i];
         argsV[12] = vthr[i];
         setFaultParameters();

         // prepare input for disloc

         int nvalues;
         if(simplex) nvalues=10;
         else nvalues=vlat.size(); 
         
         try {
          FileWriter fw = new FileWriter(dislocInput);
          fw.write(argsV[0]+" "+argsV[1]+" 0 "+nvalues+"\n");
          for(int ii=0;ii<nvalues;ii++){
	    fw.write(x[ii]+" "+y[ii]+"\n");
	  }
          fw.write("0 0 "+argsV[5]+"\n");  
          point=(new Double(argsV[13])).intValue();
          fw.write(point+" "+argsV[3]+" "+argsV[4]+" 1 1 "+argsV[7]+" "+argsV[6]+" 0 "+argsV[8]+" "+argsV[10]+"\n");
          fw.flush();
          fw.close();
	 } catch (Exception e) { System.out.println(e);}


    
         // run disloc

         String Disloc = dislocExe;
	 Disloc += " "+dislocInput+" "+dislocOutput;          
    
	 try {
           Process p = Runtime.getRuntime().exec(Disloc);
           p.waitFor();   
	 }
	 catch (Exception e) {System.out.println(e);}

	 // System.exit(0);
	 // extract data from disloc.out
 

         System.out.println("Simplex is "+simplex);

	 if(simplex) {

	     // cannot do it on my laptop
	     /*
           boolean runit=true;
           if(parm[3]>0 & i<3) runit=false;
           if(parm[3]<1 & parm[2]>0 & i<2) runit=false;
           if(parm[3]<1 & parm[2]<1 & parm[1]>0 & i<1) runit=false; 
           if(runit) {

	 try {
           Process p = Runtime.getRuntime().exec(disloc2simplex);
           p.waitFor();   
           p = Runtime.getRuntime().exec(simplexCmd);
           p.waitFor();
           System.out.println("Simplex done");
	 }
	 catch (Exception e) {System.out.println(e);}
	   }
	     */
	 }
    
      else {         //no simplex  

      StringTokenizer st1;
      double ux, uy, uz, ra;
      String dummy1;
      boolean skipline = true; 
      int nn=0;
      try {
      FileReader reader1 = new FileReader(dislocOutput);
      BufferedReader in1 = new BufferedReader(reader1);
      FileWriter w3 = new FileWriter(gemDir+"disloc3-"+i+".txt");
      while((nextLine = in1.readLine()) != null) {
         if(!skipline) {
         nn++;
         st1 = new StringTokenizer(nextLine);
         dummy1 = st1.nextToken();
         dummy1 = st1.nextToken();
         dummy1 = st1.nextToken();
         ux = (new Double(dummy1)).doubleValue();
         dummy1 = st1.nextToken();
         uy = (new Double(dummy1)).doubleValue();
         dummy1 = st1.nextToken();
         uz = (new Double(dummy1)).doubleValue();
         ra = Math.sqrt(ux*ux+uy*uy+uz*uz);
         r.addElement(new Double(ra));
         w3.write((new Double(ra)).toString()+"\n");
	 }
         else {
          if(nextLine.startsWith("  x")) skipline=false;
	 }
      }
      reader1.close();
      w3.flush();
      w3.close();
      } catch (Exception e) {System.out.println(e);}

      }   // else no simplex
    }
    }
      // sort elements of r
 
       System.out.println("about to sort");
       System.out.println("Size of r is: "+ r.size());

       rr =new double[r.size()];
 
       for(int ii=0;ii<r.size();ii++){
          rr[ii]=((Double)r.elementAt(ii)).doubleValue();
          rIdx.put(((Double)r.elementAt(ii)).toString(),new Integer(ii)); 
       }

       System.out.println("rr created");
    
       try {
       QuickSort(rr,0,r.size()-1);
       }
       catch (Exception e) {System.out.println(e+" in QuickSort");}

      int cur;
      String thisLine;
      String oldLine=" "; 

       System.out.println("write final resluts");

   try {
   FileWriter endWriter = new FileWriter(resultFile);
   //   String oldId =""; 
   Hashtable Idents = new Hashtable();
   int strLength=(nf.format(rr[rr.length-1])).length();

    
    for(int ii=rr.length-1;ii>0;ii--) {
      cur = ((Integer)rIdx.get((new Double(rr[ii])).toString())).intValue();

      String currId = (String)Ids.elementAt(cur);
      if(!Idents.containsKey(currId))  {
//      if(!currId.equals(oldId)) {
        Idents.put(currId,"exists"); 

        // first format numbers
        String rrvalue = nf.format(rr[ii]);
        int currLength=rrvalue.length();
        while(currLength<strLength){
           rrvalue = " "+rrvalue;
           currLength = rrvalue.length();
	}

        thisLine = rrvalue+" "+currId;
        thisLine += " "+(String)gvlat.elementAt(cur)+" ";
        thisLine += (String)gvlon.elementAt(cur);  
        if(rr[ii]>threshold){
        System.out.println(thisLine);
        endWriter.write(thisLine+"\n");
        }
      }
    }
   endWriter.flush();
   endWriter.close(); 
   }
   catch (Exception e) {
      System.out.println("cannot write final results");
      System.out.println(e.toString());
   }
   return argsV;
  }

   public void QuickSort(double a[], int lo0, int hi0) throws Exception {
      int lo = lo0;
      int hi = hi0;
      double mid;

      if ( hi0 > lo0)
      {

         /* Arbitrarily establishing partition element as the midpoint of
          * the array.
          */
         mid = a[ ( lo0 + hi0 ) / 2 ];

         // loop through the array until indices cross
         while( lo <= hi )
         {
            /* find the first element that is greater than or equal to 
             * the partition element starting from the left Index.
             */
            while( ( lo < hi0 ) && ( a[lo] < mid ) )
               ++lo;

            /* find an element that is smaller than or equal to 
             * the partition element starting from the right Index.
             */
            while( ( hi > lo0 ) && ( a[hi] > mid ) )
               --hi;

            // if the indexes have not crossed, swap
            if( lo <= hi ) 
            {
               swap(a, lo, hi);
               ++lo;
               --hi;
            }
         }

         /* If the right index has not reached the left side of array
          * must now sort the left partition.
          */
         if( lo0 < hi )
            QuickSort( a, lo0, hi);

         /* If the left index has not reached the right side of array
          * must now sort the right partition.
          */
         if( lo < hi0 )
            QuickSort( a, lo, hi0);

      }

   }

   private void swap(double a[], int i, int j)
   {
      double T;

      T = a[i]; 
      a[i] = a[j];
      a[j] = T;

   }

    public void setDefaultValues() {
     vdip = arrayDefault(90,90,45,45);
     vds = arrayValue(6);
     vlen = arrayValue(8);
     vss = arrayValue(7);
     vstr = arrayDefault(0,45,0,90);
     vthr = arrayDefault(0,0,1,1);    
     vwid = arrayValue(10);
     //     parm = comes as an input argument
    }

  public double[] arrayDefault(double a, double b, double c, double d) {
    double[] ar = new double[4];
     ar[0]=a;
     ar[1]=b;
     ar[2]=c;
     ar[3]=d;
    return ar; 
  } 

  public double[] arrayValue(int i) {
    double[] ar = new double[4];
    double a = argsV[i];
     ar[0]=a;
     ar[1]=a;
     ar[2]=a;
     ar[3]=a;
    return ar; 
  } 

    public void setFaultParameters(){
      // Set up fault parameters

	// magnitude flag Ms
	if(argsV[2]<7) Ms = 0; else Ms=1;

        // length   (8) 
        if(argsV[8]==0) {
	    if(argsV[6]==0 && argsV[7]==0) {   //slip (ds,ss)
		if(argsV[10]==0) {             //width
		    if(Ms==0) {
                       double d = 3*(M+10.7)/2;
                       double c = (Math.pow(10,d))/(argsV[9]*0.6E-10);
                       double b = Math.sqrt(c);
                       argsV[8] = Math.sqrt(b)/1E5;
		    }
                    else {       //Ms==1
                       double d = 3*(M+10.7)/2;
                       double c = Math.pow(10,d);
                       double b = Math.sqrt(c);
                       double a = b/(argsV[9]*0.6E-10);
                       argsV[8] = a/(argsV[10]*1E5);
		    }
		} else {          // width set by the user
                   System.out.println("Oops, I do not know what to do");
		}
	    }
            else {    //slip known
		if(Ms==0) {
                   argsV[8]=Math.sqrt(argsV[6]*argsV[6]+argsV[7]*argsV[7]);
                   argsV[8]=Math.sqrt(argsV[8]/0.6);  
		   //this comes from slip=0.6*width*length;
                   //                width=length;
                   //                slip=sqrt(ds**2 + ss**2);
                }
                else {
                   argsV[8]=Math.sqrt(argsV[6]*argsV[6]+argsV[7]*argsV[7]);
                   argsV[8]=argsV[8]/20.0;  
		   //this comes from slip=0.6*20*length;
                   //                slip=sqrt(ds**2 + ss**2);
		}
	    }
	}

        // width   (10) 
        if(argsV[10]==0) {
	    if(argsV[6]==0 && argsV[7]==0) {   //slip (ds,ss)
		    if(Ms==0) {
                       double d = 3*(M+10.7)/2;
                       double c = (Math.pow(10,d))/(argsV[9]*0.6E-10);
                       double b = Math.sqrt(c);
                       argsV[10] = Math.sqrt(b)/1E5;
		    }
                    else {       //Ms==1
                       argsV[10] = 20.0;
		    }
	    }
            else {    //slip known
		if(Ms==0) {
                   argsV[10]=Math.sqrt(argsV[6]*argsV[6]+argsV[7]*argsV[7]);
                   argsV[10]=Math.sqrt(argsV[8]/0.6);  
		   //this comes from slip=0.6*width*length;
                   //                width=length;
                   //                slip=sqrt(ds**2 + ss**2);
                }
                else {
                   argsV[10]=20.0;
		}
	    }
	}

         if(argsV[6]==0 && argsV[7]==0) {
              slip = 0.6*argsV[8]*argsV[10];
	 }

         // depth
         if(argsV[3]==0) {
	   if(argsV[13]==0) {
              argsV[3] = argsV[10]/2;
	   }
           else {
              argsV[3]=argsV[10];
	   }
	 }

         // ds and ss 
	 if(argsV[12]>0) {
          if(Math.abs(argsV[6])<1E-10) argsV[6]=slip*10;
         }
         else if(Math.abs(argsV[7])<1E-10) argsV[7]=slip*10;     
	 
    }

   
}











